// OGLRumpfprogramm.cpp : Definiert den Einsprungpunkt fr die Anwendung.

// jl: abgendert in Rumpfprogramm fr OpenGL(R)
// jl: mit opengl32.lib linken
// jl: in StdAfx.h ergnzen: #include <GL/gl.h>

#include "stdafx.h"
#include "resource.h"

#define MAX_LOADSTRING 100

// Globale Variablen:
HINSTANCE hInst; // aktuelle Instanz
TCHAR szTitle[MAX_LOADSTRING]; // Text der Titelzeile
TCHAR szWindowClass[MAX_LOADSTRING]; // Text der Titelzeile

// Vorausdeklarationen von Funktionen, die in diesem Code-Modul enthalten sind:
ATOM				MyRegisterClass( HINSTANCE hInstance );
BOOL				InitInstance( HINSTANCE, int );
LRESULT CALLBACK	WndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK	About( HWND, UINT, WPARAM, LPARAM );

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// ZU ERLEDIGEN: Fgen Sie hier den Code ein.
	MSG msg;
	HACCEL hAccelTable;

	// Globale Zeichenfolgen initialisieren
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_OGLRUMPFPROGRAMM, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Initialisierung der Anwendung durchfhren:
	if( !InitInstance( hInstance, nCmdShow ) ) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_OGLRUMPFPROGRAMM);

	// Hauptnachrichtenschleife:
	while( GetMessage(&msg, NULL, 0, 0) ) 
	{
		if( !TranslateAccelerator (msg.hwnd, hAccelTable, &msg) ) 
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}

	return msg.wParam;
}

//
//  FUNKTION: MyRegisterClass()
//
//  AUFGABE: Registriert die Fensterklasse.
//
//  KOMMENTARE:
//
//    Diese Funktion und ihre Verwendung sind nur notwendig, wenn dieser Code
//    mit Win32-Systemen vor der 'RegisterClassEx'-Funktion kompatibel sein soll,
//    die zu Windows 95 hinzugefgt wurde. Es ist wichtig diese Funktion aufzurufen,
//    damit der Anwendung kleine Symbole mit den richtigen Proportionen zugewiesen
//    werden.
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC; // jl: CS_OWNDC dazu
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_OGLRUMPFPROGRAMM);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)NULL; // jl: NULL
	wcex.lpszMenuName	= (LPCSTR)IDC_OGLRUMPFPROGRAMM;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNKTION: InitInstance(HANDLE, int)
//
//   AUFGABE: Speichert die Instanzzugriffsnummer und erstellt das Hauptfenster
//
//   KOMMENTARE:
//
//        In dieser Funktion wird die Instanzzugriffsnummer in einer globalen Variable
//        gespeichert und das Hauptprogrammfenster erstellt und angezeigt.
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
   HWND hWnd;

   hInst = hInstance; // Instanzzugriffsnummer in unserer globalen Variable speichern

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if( !hWnd ) 
   {
      return FALSE;
   }

   ShowWindow( hWnd, nCmdShow );
   UpdateWindow( hWnd );

   return TRUE;
}

//
//  FUNKTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  AUFGABE:  Verarbeitet Nachrichten fr das Hauptfenster.
//
//  WM_COMMAND	- Anwendungsmen verarbeiten
//  WM_PAINT	- Hauptfenster darstellen
//  WM_DESTROY	- Beendigungsnachricht ausgeben und zurckkehren
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	static HDC hDC = NULL;
	static HGLRC hRC = NULL;

	switch( message ) 
	{
		case WM_CREATE: // jl: ganz neu
			{ // Block, weil lokale Variablen
				hDC = GetDC(hWnd); // zum ersten und letzten Mal,
									// weil wir den DC besitzen
				static PIXELFORMATDESCRIPTOR pfd = {
					sizeof(PIXELFORMATDESCRIPTOR),
					1,
					PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL
					| PFD_DEPTH_DONTCARE,
					PFD_TYPE_RGBA,
					32,
					0,0,0,0,0,0,0,0,0,0,0,0,0,
					0,
					0,0,0,0,0,0,0 };
				int nPixelFormat = ChoosePixelFormat(hDC, &pfd);
				if(nPixelFormat != 0)
				{
					SetPixelFormat(hDC, nPixelFormat, &pfd);
					hRC = wglCreateContext(hDC);
					wglMakeCurrent(hDC, hRC);
				}
				else
				{
					MessageBox(hWnd, "Initialisierung von OpenGL fehlgeschlagen.", "Fataler Fehler", MB_ICONERROR);
					PostQuitMessage(0);
				}
			}
			break;
		case WM_SIZE: // jl: neu
			{ // Block, weil lokale Variablen
				RECT r;
				GetClientRect(hWnd, &r);
				glViewport(r.left, r.top, r.right-r.left, r.bottom-r.top);
			}
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Menauswahlen analysieren:
			switch( wmId ) 
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow( hWnd );
				   break;
				default:
				   return DefWindowProc( hWnd, message, wParam, lParam );
			}
			break;
		case WM_PAINT: // jl: komplett anders
			wglMakeCurrent(hDC, hRC);
			glClear(GL_COLOR_BUFFER_BIT);

			glBegin(GL_LINES);
				glColor3d(1.0, 0.0, 0.0); // "d" fr "double" (kein berladen in C)
				glVertex2d(-1.0,-1.0); // links _unten_! (Mauskoordinaten ggf. umrechnen)
				glVertex2d(1.0,1.0);
			glEnd();

			//probiere: GL_POINTS, GL_LINES, GL_LINE_STRIP, GL_LINE_LOOP
			//GL_POLYGON, GL_QUADS, GL_TRIANGLES
			//GL_TRIANGLE_STRIP, GL_QUAD_STRIP, GL_TRIANGLE_FAN

			glFlush();
			ValidateRect(hWnd, NULL);
			break;
		case WM_DESTROY:
			wglMakeCurrent(hDC, NULL); // jl: neu
			wglDeleteContext(hRC); // jl: neu
			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}

// Nachrichtenbehandlungsroutine fr "Info"-Feld.
LRESULT CALLBACK About( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
